package com.gxzc.zen.api.sys.model

import com.baomidou.mybatisplus.annotations.TableName
import com.gxzc.zen.common.base.BaseModel
import com.gxzc.zen.common.util.common.TreeNode
import java.io.Serializable

/**
 * <p>
 * 菜单表
 * </p>
 *
 * @author NorthLan
 * @since 2018-04-28
 */
@TableName("sys_menu")
open class SysMenu : BaseModel() {
    /**
     * 上级菜单ID(root:0)
     */
    var parentId: Long? = null
    /**
     * 路径枚举
     */
    var path: String? = null
    /**
     * 菜单编码
     */
    var code: String? = null
    /**
     * 菜单类型（0:菜单组；1:菜单；）
     */
    var type: Int? = null
    /**
     * 菜单标题
     */
    var title: String? = null
    /**
     * 请求地址（前端）
     */
    var uri: String? = null
    /**
     * 图标名称
     */
    var icon: String? = null
    /**
     * 排序号
     */
    var sort: Int? = null
    /**
     * 扩展字段1
     */
    var ext1: String? = null
    /**
     * 扩展字段2
     */
    var ext2: String? = null
    /**
     * 扩展字段3
     */
    var ext3: String? = null
    /**
     * 扩展字段4
     */
    var ext4: String? = null
    /**
     * 扩展字段5
     */
    var ext5: String? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other !is SysMenu) return false
        if (!super.equals(other)) return false

        if (parentId != other.parentId) return false
        if (path != other.path) return false
        if (code != other.code) return false
        if (type != other.type) return false
        if (title != other.title) return false
        if (uri != other.uri) return false
        if (icon != other.icon) return false
        if (sort != other.sort) return false
        if (ext1 != other.ext1) return false
        if (ext2 != other.ext2) return false
        if (ext3 != other.ext3) return false
        if (ext4 != other.ext4) return false
        if (ext5 != other.ext5) return false

        return true
    }

    override fun hashCode(): Int {
        var result = super.hashCode()
        result = 31 * result + (parentId?.hashCode() ?: 0)
        result = 31 * result + (path?.hashCode() ?: 0)
        result = 31 * result + (code?.hashCode() ?: 0)
        result = 31 * result + (type ?: 0)
        result = 31 * result + (title?.hashCode() ?: 0)
        result = 31 * result + (uri?.hashCode() ?: 0)
        result = 31 * result + (icon?.hashCode() ?: 0)
        result = 31 * result + (sort ?: 0)
        result = 31 * result + (ext1?.hashCode() ?: 0)
        result = 31 * result + (ext2?.hashCode() ?: 0)
        result = 31 * result + (ext3?.hashCode() ?: 0)
        result = 31 * result + (ext4?.hashCode() ?: 0)
        result = 31 * result + (ext5?.hashCode() ?: 0)
        return result
    }

    /////////////////////////////////////////////////
//    @TableField(exist = false)
//    var sysResource: SysResource? = null
    /////////////////////////////////////////////////


}
